DECLARE SUB GbLinkInit ()
DECLARE SUB gbwait ()
DECLARE FUNCTION GbSend! (bijt AS INTEGER)
DIM SHARED BogusIps AS LONG
GbLinkInit
FOR l = 0 TO 60000: gbwait: NEXT

PRINT "Opening file '" + COMMAND$ + "'"
ON ERROR GOTO foutje
OPEN COMMAND$ FOR INPUT AS #1: CLOSE
ON ERROR GOTO 0
PRINT "Uploading file..."
PRINT " 0% completed..."

OPEN COMMAND$ FOR BINARY AS #1
a$ = " "
b = -1
FOR x = 0 TO LOF(1)
  b = (b + 1) AND 255
  GET #1, , a$
  a = GbSend(ASC(a$))
  IF a <> b THEN
    IF LOC(1) <> 1 THEN
      PRINT "An error in the communication channel was detected. Please make sure the"
      PRINT "hardware is working and try again."
      PRINT "Now returning to command prompt..."
      PRINT
      SYSTEM
  END IF
  END IF
  IF b = 255 THEN
    IF INKEY$ = CHR$(27) THEN
      PRINT "User abort!"
      PRINT "Now returning to command prompt..."
      PRINT
      SYSTEM
    END IF
    p = LOC(1) / LOF(1)
    LOCATE 8, 1
    PRINT RTRIM$(STR$(INT(p * 100))); "% completed..."
    FOR l = 0 TO 300: gbwait: NEXT
  END IF
NEXT

LOCATE 8, 1
PRINT " 100% completed!  "
PRINT "Now returning to command prompt..."
PRINT
SYSTEM

SYSTEM
foutje:
PRINT "File '" + COMMAND$ + "'"; couldn't be opened successfully!"
PRINT "Now returning to command prompt..."
SYSTEM

DEFINT A-Z
SUB GbLinkInit
  CLS

  PRINT "Initializing parallel port..."
  OUT &H378, &H8
  PRINT "Calculating Bogus IPS..."
  t! = TIMER + .2
  WHILE t! > TIMER
    BogusIps = BogusIps + 1
  WEND
  PRINT "  Bogus IPS count:" + RTRIM$(STR$(BogusIps * 7)) + "K"

  PRINT "Initialising uplink daemon"

  DO
    t = t + 1
    IF t = 9 THEN
      PRINT " ! Failed to initialise link. Check the hardware."
      DO: LOOP WHILE INKEY$ = ""
      SYSTEM
    END IF
  
    LOCATE 4, 28: PRINT "[" + STRING$(8, 32) + "]"
    LOCATE 4, 29: PRINT STRING$(t, ".")
  
     OUT &H378, te + 0: gbwait
     OUT &H378, te + 2: gbwait
     OUT &H378, te + 0: gbwait
  
    FOR D# = 0 TO BogusIps * 2: NEXT

    IF INKEY$ = CHR$(27) THEN PRINT " ! Initialisation aborted.": SYSTEM
  LOOP WHILE GbSend(&HA0) <> &H80
  OutputDevice = -1
  LOCATE 4, 29: PRINT "........"
  PRINT "  Uplink established."


END SUB

DEFSNG A-Z
FUNCTION GbSend! (bijt AS INTEGER)
'Stuurt de byte

retn = 0
FOR x = 7 TO 0 STEP -1
  IF (bijt AND 2 ^ x) = 0 THEN te = 0 ELSE te = 1

  OUT &H378, te + 0
  gbwait
  OUT &H378, te + 2
  gbwait
   IF (INP(&H379) AND 2 ^ 5) <> 0 THEN retn = retn + (2 ^ x)
  OUT &H378, te + 0
  gbwait
NEXT
gbwait
gbwait
gbwait
GbSend! = retn

END FUNCTION

SUB gbwait
  FOR x = 0 TO (BogusIps / 1500)
    'Doe niets
  NEXT
END SUB

